Description

auto_complete_controller_name helper is used to determine both which controller to use for the auto_completion, as well as a value
for bookmarks.controller attribute. In bookmarks, we test the controller to match the database table.

In #24040, the code send("#{auto_complete_controller_name}_path") (
https://github.com/iNecas/foreman/commit/184f8d5ce23cfe208a696535bceal346074d8600a#diff-120a1¢c3293b2d4c051433c4f2c8a7a
3bL1) was replaced with url: "#{auto_complete_controller_name}/auto_complete_search", so we suddenly started to assume that
auto_complete_controller_name will automatically match the controller_path, which is not the case with nested controller (that we
have in foreman_tasks).

As a result, we've hit https://projects.theforeman.org/issues/25427 and https://projects.theforeman.org/issues/25958/.

| think the solution should be to get the auto_complete_controller_name the meaning it had before #24040, so not assuming path
where we expect the controller name, and use the Rails path helpers to determine the right url. This way, we can also check better
that the autocomplete url is actually defined.

Related issues:

Related to Foreman - Feature #24040: Move the search box in Hardware Models t... Closed
Related to foreman-tasks - Bug #25427: "Request failed with status code 404" ... Closed
Related to foreman-tasks - Bug #25958: Bookmarks not working on Monitor > Tas... Closed

Associated revisions

Revision 548c23f1 - 02/05/2019 10:24 AM - lvan Necas

Fixes #25976 - use path helper to determine auto-completion path

Commit 184f8d5ce2 changed the meaning of the
auto_complete_controller_name and assumed it will always equal to the
path, which is not the case for nested controllers (that we have

for example in foreman-tasks). As a result, this feature has been broken
there.

This commit adds back the original behavior + makes sure the

auto_complete_search is actually defined, so that we detect the missing
path sooner.

History

#1 - 02/04/2019 10:26 AM - Ivan Necas
- Found in Releases 1.20.0 added

#2 - 02/04/2019 10:26 AM - Ivan Necas

- Related to Feature #24040: Move the search box in Hardware Models to a React component added

#3 - 02/04/2019 10:26 AM - Ivan Necas
- Related to Bug #25427: "Request failed with status code 404" error on Tasks page added
https://projects.theforeman.org/issues/24040
https://github.com/iNecas/foreman/commit/184f8d5ce23cfe208a696535bcea346074d8600a#diff-120a1c3293b2d4c051433c4f2c8a7a3bL1
https://github.com/iNecas/foreman/commit/184f8d5ce23cfe208a696535bcea346074d8600a#diff-120a1c3293b2d4c051433c4f2c8a7a3bL1
https://projects.theforeman.org/issues/25427
https://projects.theforeman.org/issues/25958/
https://projects.theforeman.org/issues/24040

#4 - 02/04/2019 10:27 AM - Ivan Necas
- Related to Bug #25958: Bookmarks not working on Monitor > Tasks page added

#5 - 02/04/2019 10:30 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/6460 added

#6 - 02/05/2019 10:24 AM - Timo Goebel
- Fixed in Releases 1.22.0 added

#7 - 02/05/2019 11:02 AM - Ivan Necas
- Status changed from Ready For Testing to Closed

Applied in changeset 548c23f1280ec8ee48d40c0e0bf4f9ccbe960e5f.

#8 - 03/27/2019 10:58 AM - Ondfej Prazak
- Bugzilla link set to 1684291

#9 - 04/22/2019 07:45 AM - Tomer Brisker

- Category set to Web Interface
